﻿#define ENABLE_INT_EXTENSIONS

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

using System.Runtime.CompilerServices;

namespace AsyncUsingStandardTaskAwaiters {
	class Program {

		static async void RunTestAsync() {
			Console.WriteLine("Program.RunTestAsync in thread {0}: Initial part 1 running ...", Thread.CurrentThread.ManagedThreadId);
			
			await Task.Delay(1000);
			
			Console.WriteLine("Program.RunTestAsync in thread {0}: Part 2 after 1st await ...", Thread.CurrentThread.ManagedThreadId);
			
			await 1000;
			
			Console.WriteLine("Program.RunTestAsync in thread {0}: Part 3 after 2st await ...", Thread.CurrentThread.ManagedThreadId);
		}

		static void Main(string[] args) {
			Console.WriteLine("!!! Program.Main in thread {0}: Started ...", Thread.CurrentThread.ManagedThreadId);

			RunTestAsync();

			Console.WriteLine("!!! Program.Main in thread {0}: Sleeping ...", Thread.CurrentThread.ManagedThreadId);
			Thread.Sleep(3000);

			Console.WriteLine("!!! Program.Main in thread {0}: Ending ...", Thread.CurrentThread.ManagedThreadId);
		}
	}

#if ENABLE_INT_EXTENSIONS
	static class IntExtensions {
		public static TaskAwaiter GetAwaiter(this int msDelay) {
			return Task.Delay(msDelay).GetAwaiter();
		}
	}
#endif
}
